Subject: Re: [PATCH] strbuf: add compound literal test balloon

From: Phillip Wood <[email-masked]>
Date: Tue, 15 Jul 2025 10:44:20 +0100

Hi Patrick

On 15/07/2025 09:53, Patrick Steinhardt wrote:
> 
> We already have a two test balloons, both defined in
> "reftable/system.h":
> 
>      #define REFTABLE_FLOCK_INIT ((struct reftable_flock){ .fd = -1, })
> 
>      #define REFTABLE_TMPFILE_INIT ((struct reftable_tmpfile) { .fd = -1, })
> 
> Both of those are getting used in a way that'd break if those weren't
> properly supported in "reftable/stack.c":
> 
> 	for (i = 0; i < last - first + 1; i++)
> 		table_locks[i] = REFTABLE_FLOCK_INIT;
> 
> 	tab_file = REFTABLE_TMPFILE_INIT;
> 
> Those are rather recent additions though, released with Git 2.50. I also
> totally missed that we didn't have any test balloons for this syntax.
> Should we maybe retroactively mark them as test balloons instead of
> converting and marking some new sites?

It would definitely be worth marking them as test balloons. So long as 
it is not possible to build git without the reftable library then they 
should suffice without adding any more. I think it would be worth adding 
a section to CodingGuildlines.adoc about the balloons we current have as 
well (I didn't add that here as I wanted to wait until we knew the 
commit id that introduced the balloon).

Thanks

Phillip